"use strict";

const benchmark = require("benchmark");

const s = require("../src");

let PersonName = s.createType("PersonName", s.string({
	matches: /^[a-z0-9 '-]+$/
}));

let Person = s.createType("Person", {
	name: PersonName,
	age: s.number(),
	isAlive: s.boolean()
});

new benchmark.Suite()
	.add("normal", () => {
		let me = {
			name: "somebody",
			age: 42,
			isAlive: true
		};

		let a = (me.name, me.age, me.isAlive);
	})
	.add("strict", () => {
		let me = Person({
			name: "somebody",
			age: 42,
			isAlive: true
		});

		let a = (me.name, me.age, me.isAlive);
	})
	.on("cycle", function (event) {
		console.log(String(event.target));
	})
	.run();
