"use strict";

const errors = require("../errors");
const getValueType = require("../util/get-value-type");

module.exports = function createNothingValidatorFunction(_options = {}) {
	return function validateNothing(value) {
		if (value != null) {
			return new errors.ValidationError(`Expected nothing, got ${getValueType(value)} instead`);
		} else {
			return true;
		}
	};
};
